#include<iostream>
#include<algorithm>
#include<math.h>

using namespace std;

long long a[1234567];
int n;
long long k;

int dol, dop;

void calc(double m)
{
	dol = dop = 0;
	for(int i = 0; i < n; i++)
	{
		if(a[i] > m+k*i)
			dol++;
		else if(a[i] < m+k*i)
			dop++;
	}
}

int main()
{
	cin>>n>>k;
	for(int i = 0; i < n; i++)
		cin>>a[i];
	sort(a, a+n);
	double l = -1e15, r = 1e15, m;
	while(abs(l-r) > 1e-6)
	{
		m = (l+r)/2;
		calc(m);
		if(dol > n/2)
			l = m;
		else if(dop > n/2)
			r = m;
		else
		{
			l = r = m;
			break;
		}
	}
	long long ans = 0;
	double ll = floor(l);
	for(int i = 0; i < n; i++)
		ans += (long long)abs(a[i]-ll-k*i);
	ll = ceil(l);
	long long ans2 = 0;
	for(int i = 0; i < n; i++)
		ans2 += (long long)abs(a[i]-ll-k*i);
	
	cout<<min(ans, ans2)<<endl;
	return 0;
}
